## mongo-c-driver 1.24.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15)

project (mongo-c-driver C)

list (APPEND CMAKE_MODULE_PATH
      "${PROJECT_SOURCE_DIR}/build/cmake"
      "${PROJECT_SOURCE_DIR}/build/cmake/make_dist"
      )

include (MongoSettings)

# Subcomponents:
mongo_bool_setting(ENABLE_MONGOC "Enable the build of libmongoc libraries (The MongoDB C database driver)")
mongo_bool_setting(
   USE_SYSTEM_LIBBSON [[Use an existing libbson library (via find_package()) instead of building one from source]]
   DEFAULT VALUE OFF
   ADVANCED
)

# Deprecated option "ENABLE_BSON" is gone, but old caches may rely on SYSTEM to
# disable the libbson build. Allow ENABLE_BSON=SYSTEM only if USE_SYSTEM_LIBBSON
# is also true, to allow both ENABLE_BSON=SYSTEM and USE_SYSTEM_LIBBSON=TRUE to
# simplify downstream build scripts
if(ENABLE_BSON STREQUAL "SYSTEM" AND NOT USE_SYSTEM_LIBBSON)
   # User set ENABLE_BSON=SYSTEM, so they intend for us to build against an external
   # libbson, but they didn't set USE_SYSTEM_LIBBSON=ON, so they are probably
   # unaware of this change. Rather than miscompile, stop what we're doing:
   message(FATAL_ERROR "ENABLE_BSON=SYSTEM is no longer supported. Use USE_SYSTEM_LIBBSON=ON for the same effect.")
endif()

# Static libraries:
mongo_setting(
   ENABLE_STATIC "Enable building and installing static library archive artifacts"
   OPTIONS ON OFF BUILD_ONLY
   DEFAULT VALUE "ON"
)
if(NOT WIN32)
   mongo_bool_setting(ENABLE_PIC "Enable position-independent code when building static libraries (Not applicable on Windows)")
elseif(DEFINED ENABLE_PIC)
   # We are on Windows, and ENABLE_PIC is defined.
   message(STATUS "ENABLE_PIC=“${ENABLE_PIC}” has no effect on Windows (All Windows code is position-independent)")
else()
   # We are on Windows, and ENABLE_PIC is not defined, which is normal
endif()

# Dev mode checks:
mongo_bool_setting(
   ENABLE_MAINTAINER_FLAGS "Enable stricter build-time checks"
   DEFAULT VALUE OFF
      DEVEL EVAL [[
         if(MSVC)
            set(DEFAULT OFF)
         else()
            set(DEFAULT ON)
         endif()
      ]])

# Toggle instrumentation:
mongo_bool_setting(ENABLE_TRACING "Enable runtime tracing output in the built libmongoc (Very noisy!)"
                   DEFAULT VALUE OFF)
mongo_bool_setting(ENABLE_COVERAGE "Build code with coverage instrumentation"
                   DEFAULT VALUE OFF DEVEL VALUE ON)
mongo_bool_setting(ENABLE_DEBUG_ASSERTIONS "Build library with runtime debug assertions enabled"
                   DEFAULT VALUE OFF DEVEL VALUE ON)
# for MONGO_SANITIZE:
include(Sanitizers)

# Toggle optional components:
mongo_bool_setting(ENABLE_TESTS "Build MongoDB C Driver tests")
mongo_bool_setting(ENABLE_EXAMPLES "Build MongoDB C Driver examples")
mongo_bool_setting(ENABLE_MAN_PAGES "Build the manual pages" DEFAULT VALUE OFF)
mongo_bool_setting(ENABLE_HTML_DOCS "Build the HTML documentation" DEFAULT VALUE OFF)
mongo_bool_setting(ENABLE_UNINSTALL "Generate an 'uninstall' script and an 'uninstall' build target")

# Optional features that are ENABLED when necessary dependencies are found:
mongo_setting(ENABLE_SRV "Enable support for mongodb+srv URIs."
              OPTIONS ON OFF AUTO
              DEFAULT VALUE AUTO)
mongo_setting(ENABLE_SNAPPY "Enable Snappy compression support"
              OPTIONS ON OFF AUTO
              DEFAULT VALUE AUTO)
mongo_setting(ENABLE_ZSTD "Enable zstd compression support"
              OPTIONS ON OFF AUTO
              DEFAULT VALUE AUTO)
mongo_setting(ENABLE_ZLIB "Enable zlib compression support"
              OPTIONS BUNDLED SYSTEM OFF
              DEFAULT VALUE BUNDLED)
mongo_setting(
   ENABLE_SSL [[Enable TLS connection and SCRAM authentication.]]
   OPTIONS WINDOWS DARWIN OPENSSL LIBRESSL OFF AUTO
   DEFAULT VALUE AUTO
   VALIDATE CODE [[
      if(ENABLE_SSL STREQUAL "DARWIN" AND NOT APPLE)
         message(WARNING "ENABLE_SSL=DARWIN is only supported on Apple platforms")
      elseif(ENABLE_SSL STREQUAL "WINDOWS" AND NOT WIN32)
         message(WARNING "ENABLE_SSL=WINDOWS is only supported on Windows platforms")
      endif()
   ]]
)
mongo_bool_setting(
   ENABLE_SHM_COUNTERS "Enable memory performance counters"
   DEFAULT EVAL [[
      set(DEFAULT OFF)
      if(CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux" OR (APPLE AND CMAKE_SYSTEM_PROCESSOR MATCHES "arm64"))
         set(DEFAULT ON)
      endif()
   ]]
   VALIDATE CODE [[
      if(ENABLE_SHM_COUNTERS
         AND NOT CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux"
         AND NOT (APPLE AND CMAKE_SYSTEM_PROCESSOR MATCHES "arm64"))
         message(WARNING "ENABLE_SHM_COUNTERS=ON is only supported on Linux or ARM Darwin")
      endif()
   ]]
)

mongo_setting(
   ENABLE_SASL "Enable SASL authentication (Kerberos)"
   OPTIONS CYRUS SSPI OFF AUTO
   DEFAULT VALUE AUTO
   VALIDATE CODE [[
      if(ENABLE_SASL STREQUAL "SSPI" AND NOT WIN32)
         message(WARNING "ENABLE_SASL=SSPI is only supported on Windows platforms")
      endif()
   ]]
)

mongo_setting(ENABLE_ICU "Enable ICU support, needed for non-ASCII usernames and passwords"
              OPTIONS ON OFF AUTO
              DEFAULT VALUE AUTO)
mongo_setting(ENABLE_CLIENT_SIDE_ENCRYPTION "Enable In-Use Encryption support. Requires additional support libraries."
              OPTIONS ON OFF AUTO
              DEFAULT VALUE AUTO)
mongo_setting(ENABLE_MONGODB_AWS_AUTH "Enable support for the MONGODB-AWS authentication mechanism"
              OPTIONS ON OFF AUTO
              DEFAULT VALUE AUTO
              VALIDATE CODE [[
                  if(NOT ENABLE_MONGODB_AWS_AUTH STREQUAL "ON")
                     return()
                  endif()
                  if(MSVC AND MSVC_VERSION LESS 1900)
                     message(FATAL_ERROR "Visual Studio 2015 or newer is required for ENABLE_MONGODB_AWS_AUTH=ON")
                  elseif(ENABLE_SSL STREQUAL "OFF")
                     message(FATAL_ERROR "ENABLE_MONGODB_AWS_AUTH=ON requires that ENABLE_SSL not be 'OFF'")
                  endif()
              ]])

# Optional features that are DISABLED by default:
mongo_bool_setting(ENABLE_RDTSCP "Enable fast performance counters using the Intel RDTSCP instruction"
                   DEFAULT VALUE OFF)
mongo_bool_setting(ENABLE_APPLE_FRAMEWORK "Build libraries as Apple Frameworks on Darwin platforms"
                   DEFAULT VALUE OFF)
mongo_bool_setting(
   ENABLE_CRYPTO_SYSTEM_PROFILE "Use system crypto profile"
   DEFAULT VALUE OFF
   VALIDATE CODE [[
      if(ENABLE_CRYPTO_SYSTEM_PROFILE AND NOT ENABLE_SSL STREQUAL "OPENSSL")
         message(WARNING "ENABLE_CRYPTO_SYSTEM_PROFILE=TRUE is only applicable when ENABLE_SSL=OPENSSL")
      endif()
   ]]
)

# Deprecated options:
mongo_bool_setting(
   ENABLE_AUTOMATIC_INIT_AND_CLEANUP
      "[Deprecated] Enable automatic initialization of the C driver library"
   DEFAULT EVAL [[
         set(DEFAULT OFF)
         if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
            message(VERBOSE "For backwards compatibility, when using GCC the default of "
                            "ENABLE_AUTOMATIC_INIT_AND_CLEANUP is ON")
            set(DEFAULT ON)
         endif()
      ]]
      DEVEL VALUE OFF
   VALIDATE CODE [[
      if(ENABLE_AUTOMATIC_INIT_AND_CLEANUP)
         if(NOT CMAKE_C_COMPILER_ID STREQUAL "GNU")
            message(WARNING "ENABLE_AUTOMATIC_INIT_AND_CLEANUP is only supported on GCC.")
         endif()
         message(DEPRECATION
                  "Enabling ENABLE_AUTOMATIC_INIT_AND_CLEANUP is deprecated and "
                  "may be removed in a future release")
      endif()
   ]]
)
mongo_bool_setting(
   ENABLE_EXTRA_ALIGNMENT
      "[Deprecated] Enable extra alignment on libbson types"
   DEFAULT VALUE ON
      DEVEL VALUE OFF
   VALIDATE CODE [[
      if(ENABLE_EXTRA_ALIGNMENT AND MONGO_SANITIZE MATCHES "undefined")
         message(WARNING "ENABLE_EXTRA_ALIGNMENT=“${ENABLE_EXTRA_ALIGNMENT}” will create conflicts with UndefinedBehaviorSanitizer")
      endif()
   ]]
)

# Optionally enable C++ to do some C++-specific tests
include (CheckLanguage)
check_language (CXX)
if (CMAKE_CXX_COMPILER)
   enable_language (CXX)
   if (NOT CMAKE_CXX_STANDARD)
      # Default to C++11 for purposes of testing.
      set (CMAKE_CXX_STANDARD 11)
   endif ()
else ()
   message (STATUS "No CXX support")
endif ()

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
   set (CMAKE_BUILD_TYPE "RelWithDebInfo")
   message (
      STATUS "No CMAKE_BUILD_TYPE selected, defaulting to ${CMAKE_BUILD_TYPE}"
   )
endif ()

include (InstallRequiredSystemLibraries)
include (GNUInstallDirs)
include (CMakeDependentOption)

include(MongoC-Warnings)

# Enable CCache, if possible
include (CCache)

# Link with LLD, if possible
if (NOT MSVC)
   include (LLDLinker)
endif ()

set (BUILD_VERSION "0.0.0" CACHE STRING "Library version (for both libbson and libmongoc)")

include (ParseVersion)

# Set MONGOC_MAJOR_VERSION, MONGOC_MINOR_VERSION, etc.
if (BUILD_VERSION STREQUAL "0.0.0")
   if (EXISTS ${PROJECT_SOURCE_DIR}/VERSION_CURRENT)
      file (STRINGS ${PROJECT_SOURCE_DIR}/VERSION_CURRENT BUILD_VERSION)
      message (STATUS "file VERSION_CURRENT contained BUILD_VERSION ${BUILD_VERSION}")
   else ()
      find_package (PythonInterp)
      if (PYTHONINTERP_FOUND)
         execute_process (
            COMMAND ${PYTHON_EXECUTABLE} build/calc_release_version.py
            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
            OUTPUT_VARIABLE CALC_RELEASE_VERSION
            RESULT_VARIABLE CALC_RELEASE_VERSION_RESULT
            OUTPUT_STRIP_TRAILING_WHITESPACE
         )
         if (NOT CALC_RELEASE_VERSION_RESULT STREQUAL 0)
            # If python failed above, stderr would tell the user about it
            message (FATAL_ERROR
               "BUILD_VERSION not specified and could not be calculated\
 (script invocation failed); specify in CMake command, -DBUILD_VERSION=<version>"
            )
         else ()
            set (BUILD_VERSION ${CALC_RELEASE_VERSION})
            message (STATUS "calculated BUILD_VERSION ${BUILD_VERSION}")
         endif ()
      else ()
         message (FATAL_ERROR
            "BUILD_VERSION not specified and could not be calculated\
 (Python was not found on the system); specify in CMake command, -DBUILD_VERSION=<version>"
         )
      endif ()
      message (STATUS "storing BUILD_VERSION ${BUILD_VERSION} in file VERSION_CURRENT for later use")
      file (WRITE ${PROJECT_SOURCE_DIR}/VERSION_CURRENT ${BUILD_VERSION})
   endif ()
else ()
   message (STATUS "storing BUILD_VERSION ${BUILD_VERSION} in file VERSION_CURRENT for later use")
   file (WRITE ${PROJECT_SOURCE_DIR}/VERSION_CURRENT ${BUILD_VERSION})
endif ()

include (LoadVersion)
LoadVersion (${PROJECT_SOURCE_DIR}/VERSION_CURRENT MONGOC)

# Enable "maintainer flags," which are supplementary but not mandatory.
# (As opposed to MongoC-Warnings.cmake, which are required warnings)
include (MaintainerFlags)

if ( (ENABLE_BUILD_DEPENDECIES STREQUAL OFF) AND (NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR) )
   set (ENABLE_BUILD_DEPENDECIES ON)
endif ()

_mongo_pick(BSON_EXTRA_ALIGN 1 0 ENABLE_EXTRA_ALIGNMENT)

_mongo_pick(MONGOC_ENABLE_RDTSCP 1 0 ENABLE_RDTSCP)

_mongo_pick(MONGOC_ENABLE_STATIC_BUILD 1 0 ENABLE_STATIC)
_mongo_pick(MONGOC_ENABLE_STATIC_INSTALL 1 0
            [[ENABLE_STATIC AND NOT ENABLE_STATIC STREQUAL "BUILD_ONLY"]])

if (USE_SYSTEM_LIBBSON)
   # The input variable BSON_ROOT_DIR is respected for backwards compatibility,
   # but you should use the standard CMAKE_PREFIX_PATH instead.
   message (STATUS "Searching for libbson CMake packages")
   find_package (bson-1.0
      "${MONGOC_MAJOR_VERSION}.${MONGOC_MINOR_VERSION}.${MONGOC_MICRO_VERSION}"
      HINTS
      ${BSON_ROOT_DIR})

   if (NOT bson-1.0_FOUND)
      message (FATAL_ERROR "System libbson not found")
   endif ()

   message (STATUS "libbson found version \"${bson-1.0_VERSION}\"")
   message (STATUS "disabling test-libmongoc since using system libbson")
   SET (ENABLE_TESTS OFF)

=== src/libmongoc/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)

project (libmongoc C)

include (MongoC-Warnings)

include (InstallRequiredSystemLibraries)
include (CheckStructHasMember)

message (STATUS "libmongoc version (from VERSION_CURRENT file): ${MONGOC_VERSION}")

# Defaults.
set (MONGOC_ENABLE_SSL 0)
set (MONGOC_ENABLE_SSL_OPENSSL 0)
set (MONGOC_HAVE_ASN1_STRING_GET0_DATA 0)
set (MONGOC_ENABLE_SSL_LIBRESSL 0)
set (MONGOC_ENABLE_SSL_SECURE_TRANSPORT 0)
set (MONGOC_ENABLE_SSL_SECURE_CHANNEL 0)

set (MONGOC_ENABLE_CRYPTO 0)
set (MONGOC_ENABLE_CRYPTO_LIBCRYPTO 0)
set (MONGOC_ENABLE_CRYPTO_COMMON_CRYPTO 0)
set (MONGOC_ENABLE_CRYPTO_CNG 0)

set (MONGOC_ENABLE_CRYPTO_SYSTEM_PROFILE 0)

set (MONGOC_ENABLE_COMPRESSION 0)
set (MONGOC_ENABLE_COMPRESSION_SNAPPY 0)
set (MONGOC_ENABLE_COMPRESSION_ZLIB 0)
set (MONGOC_ENABLE_COMPRESSION_ZSTD 0)

set (MONGOC_OUTPUT_BASENAME "mongoc" CACHE STRING "Output mongoc library base name")

if (NOT ENABLE_ZLIB MATCHES "SYSTEM|AUTO|BUNDLED|OFF")
   message (FATAL_ERROR
      "ENABLE_ZLIB option must be SYSTEM, BUNDLED, AUTO, or OFF"
      )
endif ()

if (NOT ENABLE_ZSTD MATCHES "ON|AUTO|OFF")
   message (FATAL_ERROR "ENABLE_ZSTD option must be ON, AUTO, or OFF")
endif ()

# Copy zconf.h.in to zconf.h; even when using system zlib, the 'dist' target
# will look for zconf.h in that location.
configure_file (
   "${SOURCE_DIR}/src/zlib-1.2.13/zconf.h.in"
   "${CMAKE_BINARY_DIR}/src/zlib-1.2.13/zconf.h"
   COPYONLY
)
set (ZLIB_INCLUDE_DIRS "")
if (ENABLE_ZLIB MATCHES "SYSTEM|AUTO")
   message (STATUS "Searching for zlib CMake packages")
   include (FindZLIB)
   if (ZLIB_FOUND)
      message (STATUS "   zlib found version \"${ZLIB_VERSION_STRING}\"")
      message (STATUS "   zlib include path \"${ZLIB_INCLUDE_DIRS}\"")
      message (STATUS "   zlib libraries \"${ZLIB_LIBRARIES}\"")
   else ()
      if (ENABLE_ZLIB STREQUAL "SYSTEM")
         message (FATAL_ERROR
            "Unable to find system zlib package. Either specify the zlib \
            location by setting ZLIB_ROOT, or else set ENABLE_ZLIB=BUNDLED or \
            set ENABLE_ZLIB=OFF."
            )
      endif ()
      set (ZLIB_LIBRARIES "")
   endif ()
endif ()

if ( (ENABLE_ZLIB STREQUAL "BUNDLED")
   OR (ENABLE_ZLIB STREQUAL "AUTO" AND NOT ZLIB_FOUND) )
   message (STATUS "Enabling zlib compression (bundled)")
   add_library (zlib_obj OBJECT "${ZLIB_SOURCES}")
   set_property (TARGET zlib_obj PROPERTY POSITION_INDEPENDENT_CODE TRUE)
   # This tells the bundled zlib where to find its generated headers
   target_include_directories (zlib_obj
      BEFORE PUBLIC
      "${SOURCE_DIR}/src/zlib-1.2.13"
      "${CMAKE_BINARY_DIR}/src/zlib-1.2.13"
   )
   # Disable all warnings for compiling Zlib
   target_compile_options (zlib_obj PRIVATE -w)
   set (SOURCES ${SOURCES} $<TARGET_OBJECTS:zlib_obj>)
   # This tells mongoc_shared/mongoc_static where to find generated zlib headers
   set (
      ZLIB_INCLUDE_DIRS
      "${SOURCE_DIR}/src/zlib-1.2.13"
      "${CMAKE_BINARY_DIR}/src/zlib-1.2.13"
   )
endif ()

if (NOT ENABLE_ZLIB STREQUAL "OFF")
   # At this point the system zlib was found, or the bundled library was used
   include (CheckIncludeFiles)
   check_include_files ("unistd.h" HAVE_UNISTD_H)
   check_include_files ("stdarg.h" HAVE_STDARG_H)
   if (HAVE_UNISTD_H)
      add_definitions (-DHAVE_UNISTD_H)
   endif ()
   if (HAVE_STDARG_H)
      add_definitions (-DHAVE_STDARG_H)
   endif ()
   set (MONGOC_ENABLE_COMPRESSION 1)
   set (MONGOC_ENABLE_COMPRESSION_ZLIB 1)
else ()
   message (STATUS "Disabling zlib compression")
endif ()


if (NOT ENABLE_ZSTD STREQUAL OFF)
   message (STATUS "Searching for compression library zstd")
   find_package(PkgConfig)
   pkg_check_modules (ZSTD libzstd)

   if (NOT ZSTD_FOUND)
      if (ENABLE_ZSTD MATCHES "ON")
         message (FATAL_ERROR "  Not found")
      else ()
         message (STATUS "  Not found")
      endif ()
   # The compression format below this version isn't supported. See SERVER-43070
   elseif (${ZSTD_VERSION} VERSION_LESS "0.8.0")
      if (ENABLE_ZSTD MATCHES "ON")
         message (FATAL_ERROR "Detected zstd version ${ZSTD_VERSION} but version 0.8.0 required")
      else ()
         message (STATUS "Detected zstd version ${ZSTD_VERSION} but version 0.8.0 required")
      endif ()
   else ()
      message (STATUS "  Found zstd version ${ZSTD_VERSION} in ${ZSTD_INCLUDE_DIRS}")
      set (MONGOC_ENABLE_COMPRESSION 1)
      set (MONGOC_ENABLE_COMPRESSION_ZSTD 1)

      include_directories (${ZSTD_INCLUDE_DIRS})
      link_directories (${ZSTD_LIBRARY_DIRS})
      if (${CMAKE_VERSION} VERSION_LESS "3.12.0")
         set (MONGOC_ZSTD_LIBRARIES ${ZSTD_LIBRARIES})
      else ()
         set (MONGOC_ZSTD_LIBRARIES ${ZSTD_LINK_LIBRARIES})
      endif ()
   endif()
endif()

if (NOT ENABLE_SSL STREQUAL OFF)
   # Try OpenSSL automatically everywhere but Mac and Windows.
   if (ENABLE_SSL STREQUAL "OPENSSL"
       OR (NOT APPLE AND NOT WIN32 AND ENABLE_SSL STREQUAL "AUTO"))
      # Sets OPENSSL_FOUND on success.
      include (FindOpenSSL)
   endif ()

   if (ENABLE_SSL STREQUAL LIBRESSL)
      include (FindPkgConfig)
      message (STATUS " Searching for LibreSSL/libtls")
      pkg_check_modules (LIBRESSL libtls)
      if (LIBRESSL_FOUND)
         message (STATUS "   Found ${LIBRESSL_LIBRARIES}")
         set (SSL_LIBRARIES ${LIBRESSL_LIBRARIES})
         if (LIBRESSL_INCLUDE_DIRS)
           include_directories ("${LIBRESSL_INCLUDE_DIRS}")
         endif ()
         link_directories ("${LIBRESSL_LIBRARY_DIRS}")
         set (LIBRESSL 1)
      else ()
         message (STATUS "   Not found")
      endif ()
   endif ()

   if (ENABLE_SSL STREQUAL DARWIN OR (APPLE AND ENABLE_SSL STREQUAL "AUTO"))
      if (APPLE)
         set (SECURE_TRANSPORT 1)
      else ()
         message (FATAL_ERROR "ENABLE_SSL=DARWIN only supported on Mac OS X")
      endif ()
   endif ()

   if (ENABLE_SSL STREQUAL WINDOWS OR (WIN32 AND ENABLE_SSL STREQUAL "AUTO"))
      if (WIN32)
         set (SECURE_CHANNEL 1)
      else ()
         message (FATAL_ERROR "ENABLE_SSL=WINDOWS only supported on Windows")
      endif ()
   endif ()

   if (NOT OPENSSL_FOUND AND NOT SECURE_TRANSPORT AND NOT SECURE_CHANNEL AND NOT LIBRESSL)
      if (ENABLE_SSL STREQUAL AUTO)
         set (ENABLE_SSL OFF)
      else ()
         message (FATAL_ERROR "No SSL library found")
      endif ()
   endif ()
endif ()

if (OPENSSL_FOUND)
   if (WIN32 AND OPENSSL_VERSION VERSION_GREATER 1.1 AND
         ${CMAKE_VERSION} VERSION_LESS 3.7)
      message (FATAL_ERROR "Building against OpenSSL 1.1.0 and later requires CMake 3.7 or later (hint:"
         " You can also compile against Windows Secure Transport with -DENABLE_SSL=WINDOWS")
   endif ()
   if (APPLE AND NOT OPENSSL_ROOT_DIR)
      message (WARNING "Building with OpenSSL but OPENSSL_ROOT_DIR not defined. If build fails to link"
         " to OpenSSL, define OPENSSL_ROOT_DIR as the path to the OpenSSL installation directory.")
   endif ()
   include (CheckLibraryExists)
   # Check for newer OpenSSL string function.
   check_library_exists ("${OPENSSL_CRYPTO_LIBRARY}"
      ASN1_STRING_get0_data "openssl/asn1.h" HAVE_ASN1_STRING_GET0_DATA
   )
   if (HAVE_ASN1_STRING_GET0_DATA)
      set (MONGOC_HAVE_ASN1_STRING_GET0_DATA 1)
   endif ()
   set (MONGOC_ENABLE_SSL 1)
   set (MONGOC_ENABLE_SSL_OPENSSL 1)
   set (MONGOC_ENABLE_CRYPTO 1)
   set (MONGOC_ENABLE_CRYPTO_LIBCRYPTO 1)
elseif (SECURE_TRANSPORT)
   set (MONGOC_ENABLE_SSL 1)
   set (MONGOC_ENABLE_SSL_SECURE_TRANSPORT 1)
   set (MONGOC_ENABLE_CRYPTO 1)
   set (MONGOC_ENABLE_CRYPTO_COMMON_CRYPTO 1)
elseif (SECURE_CHANNEL)
   set (MONGOC_ENABLE_SSL 1)
   set (MONGOC_ENABLE_SSL_SECURE_CHANNEL 1)
   set (MONGOC_ENABLE_CRYPTO 1)
   set (MONGOC_ENABLE_CRYPTO_CNG 1)
elseif (LIBRESSL)
   set (MONGOC_ENABLE_SSL 1)
   set (MONGOC_ENABLE_SSL_LIBRESSL 1)
   set (MONGOC_ENABLE_CRYPTO 1)
   set (MONGOC_ENABLE_CRYPTO_LIBCRYPTO 1)
endif ()

if (ENABLE_CRYPTO_SYSTEM_PROFILE)
   if (OPENSSL_FOUND)
      set (MONGOC_ENABLE_CRYPTO_SYSTEM_PROFILE 1)
   else ()
      message (FATAL_ERROR "ENABLE_CRYPTO_SYSTEM_PROFILE only available with OpenSSL")
   endif ()
endif ()

if (MONGOC_ENABLE_MONGODB_AWS_AUTH AND ENABLE_SSL STREQUAL OFF)
   message (FATAL_ERROR "ENABLE_MONGODB_AWS_AUTH but no SSL library was found")
endif ()

# Defaults.
set (MONGOC_ENABLE_SASL 0)
set (MONGOC_ENABLE_SASL_CYRUS 0)
set (MONGOC_ENABLE_SASL_SSPI 0)
set (MONGOC_HAVE_SASL_CLIENT_DONE 0)

if (NOT ENABLE_SASL STREQUAL OFF)
   if ( (ENABLE_SASL MATCHES "SSPI|AUTO") AND WIN32)
      set (MONGOC_ENABLE_SASL 1)
      set (MONGOC_ENABLE_SASL_SSPI 1)
   elseif (ENABLE_SASL MATCHES "AUTO|CYRUS")
      # Sets SASL_LIBRARIES.
      include (FindSASL2)
      if (SASL_FOUND)
         set (MONGOC_ENABLE_SASL 1)
         set (MONGOC_ENABLE_SASL_CYRUS 1)
      elseif (ENABLE_SASL STREQUAL "CYRUS")
          message (FATAL_ERROR "ENABLE_SASL=CYRUS could not be satisfied")
      endif()
   endif ()
endif ()


if (ENABLE_AUTOMATIC_INIT_AND_CLEANUP)
   set (MONGOC_NO_AUTOMATIC_GLOBALS 0)
else ()
   set (MONGOC_NO_AUTOMATIC_GLOBALS 1)
endif ()

include (CheckTypeSize)
if (WIN32)
   SET (CMAKE_EXTRA_INCLUDE_FILES "ws2tcpip.h")
else ()
   SET (CMAKE_EXTRA_INCLUDE_FILES "sys/socket.h")
endif ()
CHECK_TYPE_SIZE (socklen_t HAVE_SOCKLEN)
SET (CMAKE_EXTRA_INCLUDE_FILES)

if (HAVE_SOCKLEN)
   set (MONGOC_HAVE_SOCKLEN 1)
   set (MONGOC_SOCKET_ARG3 "socklen_t")
else ()
   set (MONGOC_HAVE_SOCKLEN 0)
   set (MONGOC_SOCKET_ARG3 "int")
endif ()

include (FindResSearch)
include (CheckSchedGetCPU)

function (mongoc_get_accept_args ARG2 ARG3)
   SET (VAR 0)
   foreach (ARG2_VAL "struct sockaddr" "void")
   foreach (ARG3_VAL "socklen_t" "size_t" "int")

   MATH (EXPR VAR "${VAR}+1")

   FILE (WRITE ${CMAKE_CURRENT_BINARY_DIR}/accept_test${VAR}.c
   "#include <sys/types.h>
    #include <sys/socket.h>

    int main ()
    {
      int a = 0;
      ${ARG2_VAL} *b = 0;
      ${ARG3_VAL} *c = 0;
      accept (a, b, c);
      return 0;
   }
   ")

   TRY_COMPILE (RES ${CMAKE_CURRENT_BINARY_DIR}
   ${CMAKE_CURRENT_BINARY_DIR}/accept_test${VAR}.c CMAKE_FLAGS
   "-Werror -DCMAKE_CXX_LINK_EXECUTABLE='echo not linking now...'" OUTPUT_VARIABLE LOG2)

   if (RES)
      message (
         STATUS
         "Detected parameters: accept (int, ${ARG2_VAL} *, ${ARG3_VAL} *)")

      set (${ARG2} ${ARG2_VAL} PARENT_SCOPE)
      set (${ARG3} ${ARG3_VAL} PARENT_SCOPE)
      return ()
   endif ()

   endforeach ()
   endforeach ()

endfunction ()

# Reasonable defaults.
set (MONGOC_SOCKET_ARG2 "struct sockaddr")
set (MONGOC_SOCKET_ARG3 "socklen_t")

if (NOT WIN32)
   mongoc_get_accept_args (MONGOC_SOCKET_ARG2 MONGOC_SOCKET_ARG3)
endif ()

set (MONGOC_API_VERSION 1.0)

set (CPACK_PACKAGE_VERSION_MAJOR ${MONGOC_MAJOR_VERSION})
set (CPACK_PACKAGE_VERSION_MINOR ${MONGOC_MINOR_VERSION})

set (MONGOC_CC ${CMAKE_C_COMPILER})
set (MONGOC_USER_SET_CFLAGS ${CMAKE_C_FLAGS})
set (MONGOC_USER_SET_LDFLAGS ${CMAKE_EXE_LINKER_FLAGS})

if (ENABLE_TRACING)
   set (MONGOC_TRACE 1)
else ()
   set (MONGOC_TRACE 0)
endif ()

# Sets SNAPPY_LIBRARIES and SNAPPY_INCLUDE_DIRS.
include (FindSnappy)
if (SNAPPY_INCLUDE_DIRS)
   set (MONGOC_ENABLE_COMPRESSION 1)
   include_directories ("${SNAPPY_INCLUDE_DIRS}")
endif ()

set (MONGOC_ENABLE_SHM_COUNTERS 0)

if (ENABLE_SHM_COUNTERS)
   set (MONGOC_ENABLE_SHM_COUNTERS 1)
   find_library(RT_LIBRARY rt HINTS /usr/lib32)
   if (RT_LIBRARY)
      set (SHM_LIBRARIES rt)
   endif ()
endif ()

if (NOT ENABLE_ICU MATCHES "AUTO|ON|OFF")
   message (FATAL_ERROR, "ENABLE_ICU option must be AUTO, ON, or OFF")
endif()

if (NOT ENABLE_ICU STREQUAL OFF)
   if (ENABLE_ICU STREQUAL ON)
      # do not suppress log output if find_package cannot find ICU
      find_package (ICU COMPONENTS uc)
   elseif (ENABLE_ICU STREQUAL AUTO)
      find_package (ICU QUIET COMPONENTS uc)
   endif()
   if (ICU_FOUND)
      set (MONGOC_ENABLE_ICU 1)
      include_directories ("${ICU_INCLUDE_DIR}")
   elseif (ENABLE_ICU STREQUAL ON)

=== src/libmongoc/src/mongoc/CMakeLists.txt ===
set (src_libmongoc_src_mongoc_DIST_defs
   op-delete.def
   op-get-more.def
   op-header.def
   op-insert.def
   op-kill-cursors.def
   op-msg.def
   op-query.def
   op-reply.def
   op-reply-header.def
   op-update.def
   op-compressed.def
   mongoc-counters.defs
)

set (src_libmongoc_src_mongoc_DIST_hs
   mongoc-apm.h
   mongoc-bulk-operation.h
   mongoc-change-stream.h
   mongoc-client.h
   mongoc-client-pool.h
   mongoc-client-side-encryption.h
   mongoc-collection.h
   mongoc-cursor.h
   mongoc-database.h
   mongoc-error.h
   mongoc-find-and-modify.h
   mongoc-flags.h
   mongoc-gridfs-bucket.h
   mongoc-gridfs-file.h
   mongoc-gridfs-file-list.h
   mongoc-gridfs-file-page.h
   mongoc-gridfs.h
   mongoc.h
   mongoc-handshake.h
   mongoc-host-list.h
   mongoc-index.h
   mongoc-init.h
   mongoc-iovec.h
   mongoc-log.h
   mongoc-macros.h
   mongoc-matcher.h
   mongoc-opcode.h
   mongoc-optional.h
   mongoc-prelude.h
   mongoc-rand.h
   mongoc-read-concern.h
   mongoc-read-prefs.h
   mongoc-server-api.h
   mongoc-server-description.h
   mongoc-client-session.h
   mongoc-socket.h
   mongoc-ssl.h
   mongoc-stream-buffered.h
   mongoc-stream-file.h
   mongoc-stream-gridfs.h
   mongoc-stream.h
   mongoc-stream-socket.h
   mongoc-stream-tls.h
   mongoc-stream-tls-libressl.h
   mongoc-stream-tls-openssl.h
   mongoc-stream-tls-secure-channel.h
   mongoc-stream-tls-secure-transport.h
   mongoc-topology-description.h
   mongoc-uri.h
   mongoc-version-functions.h
   mongoc-version.h.in
   mongoc-write-concern.h
   utlist.h
   forwarding/mongoc.h
)
extra_dist_generated (
   mongoc-version.h
)

set (src_libmongoc_src_mongoc_DIST_noinst_hs
   mcd-azure.h
   mcd-integer.h
   mcd-rpc.h
   mcd-time.h
   mongoc-aggregate-private.h
   mongoc-apm-private.h
   mongoc-array-private.h
   mongoc-async-cmd-private.h
   mongoc-async-private.h
   mongoc-buffer-private.h
   mongoc-bulk-operation-private.h
   mongoc-change-stream-private.h
   mongoc-client-pool-private.h
   mongoc-client-private.h
   mongoc-client-side-encryption-private.h
   mongoc-cluster-aws-private.h
   mongoc-cluster-cyrus-private.h
   mongoc-cluster-private.h
   mongoc-cluster-sasl-private.h
   mongoc-cluster-sspi-private.h
   mongoc-cluster-sspi-private.h
   mongoc-cmd-private.h
   mongoc-collection-private.h
   mongoc-compression-private.h
   mongoc-config.h.in
   mongoc-counters-private.h
   mongoc-crypt-private.h
   mongoc-crypto-cng-private.h
   mongoc-crypto-common-crypto-private.h
   mongoc-crypto-openssl-private.h
   mongoc-crypto-private.h
   mongoc-cursor-private.h
   mongoc-cyrus-private.h
   mongoc-database-private.h
   mongoc-errno-private.h
   mongoc-error-private.h
   mongoc-find-and-modify-private.h
   mongoc-flags-private.h
   mongoc-generation-map-private.h
   mongoc-gridfs-bucket-file-private.h
   mongoc-gridfs-bucket-private.h
   mongoc-gridfs-file-list-private.h
   mongoc-gridfs-file-page-private.h
   mongoc-gridfs-file-private.h
   mongoc-gridfs-private.h
   mongoc-handshake-compiler-private.h
   mongoc-handshake-os-private.h
   mongoc-handshake-private.h
   mongoc-host-list-private.h
   mongoc-http-private.h
   mongoc-interrupt-private.h
   mongoc-libressl-private.h
   mongoc-linux-distro-scanner-private.h
   mongoc-list-private.h
   mongoc-log-private.h
   mongoc-matcher-op-private.h
   mongoc-matcher-private.h
   mongoc-memcmp-private.h
   mongoc-ocsp-cache-private.h
   mongoc-openssl-private.h
   mongoc-opts-private.h
   mongoc-opts-helpers-private.h
   mongoc-queue-private.h
   mongoc-rand-private.h
   mongoc-read-concern-private.h
   mongoc-read-prefs-private.h
   mongoc-rpc-private.h
   mongoc-sasl-private.h
   mongoc-client-session-private.h
   mongoc-sspi-private.h
   mongoc-scram-private.h
   mongoc-secure-channel-private.h
   mongoc-secure-transport-private.h
   mongoc-server-api-private.h
   mongoc-server-description-private.h
   mongoc-server-stream-private.h
   mongoc-server-monitor-private.h
   mongoc-set-private.h
   mongoc-shared-private.h
   mongoc-socket-private.h
   mongoc-ssl-private.h
   mongoc-sspi-private.h
   mongoc-stream-private.h
   mongoc-stream-tls-libressl-private.h
   mongoc-stream-tls-openssl-bio-private.h
   mongoc-stream-tls-openssl-private.h
   mongoc-stream-tls-private.h
   mongoc-stream-tls-secure-channel-private.h
   mongoc-stream-tls-secure-transport-private.h
   mongoc-stream-gridfs-download-private.h
   mongoc-stream-gridfs-upload-private.h
   mongoc-thread-private.h
   mongoc-timeout-private.h
   mongoc-topology-description-apm-private.h
   mongoc-topology-description-private.h
   mongoc-topology-private.h
   mongoc-topology-background-monitoring-private.h
   mongoc-topology-scanner-private.h
   mongoc-trace-private.h
   mongoc-ts-pool-private.h
   mongoc-uri-private.h
   mongoc-util-private.h
   mongoc-write-command-private.h
   mongoc-write-concern-private.h
   service-gcp.h
)

set (src_libmongoc_src_mongoc_DIST_cs
   mcd-azure.c
   mcd-rpc.c
   mongoc-aggregate.c
   mongoc-apm.c
   mongoc-array.c
   mongoc-async.c
   mongoc-async-cmd.c
   mongoc-topology-background-monitoring.c
   mongoc-buffer.c
   mongoc-bulk-operation.c
   mongoc-change-stream.c
   mongoc-client.c
   mongoc-client-pool.c
   mongoc-client-side-encryption.c
   mongoc-cluster.c
   mongoc-cluster-aws.c
   mongoc-collection.c
   mongoc-compression.c
   mongoc-counters.c
   mongoc-crypt.c
   mongoc-cursor.c
   mongoc-cursor-legacy.c
   mongoc-cursor-array.c
   mongoc-cursor-find.c
   mongoc-cursor-find-cmd.c
   mongoc-cursor-find-opquery.c
   mongoc-cursor-cmd.c
   mongoc-cursor-change-stream.c
   mongoc-cursor-cmd-deprecated.c
   mongoc-database.c
   mongoc-error.c
   mongoc-flags.c
   mongoc-find-and-modify.c
   mongoc-generation-map.c
   mongoc-host-list.c
   mongoc-init.c
   mongoc-interrupt.c
   mongoc-gridfs.c
   mongoc-gridfs-bucket.c
   mongoc-gridfs-bucket-file.c
   mongoc-gridfs-file.c
   mongoc-gridfs-file-page.c
   mongoc-gridfs-file-list.c
   mongoc-handshake.c
   mongoc-http.c
   mongoc-index.c
   mongoc-linux-distro-scanner.c
   mongoc-list.c
   mongoc-log.c
   mongoc-matcher-op.c
   mongoc-matcher.c
   mongoc-memcmp.c
   mongoc-cmd.c
   mongoc-ocsp-cache.c
   mongoc-opcode.c
   mongoc-optional.c
   mongoc-opts.c
   mongoc-opts-helpers.c
   mongoc-queue.c
   mongoc-read-concern.c
   mongoc-read-prefs.c
   mongoc-rpc.c
   mongoc-server-api.c
   mongoc-server-description.c
   mongoc-server-stream.c
   mongoc-client-session.c
   mongoc-set.c
   mongoc-server-monitor.c
   mongoc-shared.c
   mongoc-socket.c
   mongoc-stream.c
   mongoc-stream-buffered.c
   mongoc-stream-file.c
   mongoc-stream-gridfs.c
   mongoc-stream-gridfs-download.c
   mongoc-stream-gridfs-upload.c
   mongoc-stream-socket.c
   mongoc-timeout.c
   mongoc-topology.c
   mongoc-topology-description.c
   mongoc-topology-description-apm.c
   mongoc-topology-scanner.c
   mongoc-ts-pool.c
   mongoc-uri.c
   mongoc-util.c
   mongoc-version-functions.c
   mongoc-write-command.c
   mongoc-write-concern.c
   mongoc-crypto.c
   mongoc-scram.c
   mongoc-crypto-openssl.c
   mongoc-rand-openssl.c
   mongoc-crypto-common-crypto.c
   mongoc-rand-common-crypto.c
   mongoc-crypto-cng.c
   mongoc-rand-cng.c
   mongoc-stream-tls.c
   mongoc-ssl.c
   mongoc-libressl.c
   mongoc-stream-tls-libressl.c
   mongoc-openssl.c
   mongoc-stream-tls-openssl.c
   mongoc-stream-tls-openssl-bio.c
   mongoc-secure-transport.c
   mongoc-stream-tls-secure-transport.c
   mongoc-secure-channel.c
   mongoc-stream-tls-secure-channel.c
   mongoc-cluster-sasl.c
   mongoc-sasl.c
   mongoc-cluster-cyrus.c
   mongoc-cyrus.c
   mongoc-cluster-sspi.c
   mongoc-sspi.c
   service-gcp.c
)

set_dist_list (src_libmongoc_src_mongoc_DIST
   CMakeLists.txt
   modules/module.modulemap.in
   ${src_libmongoc_src_mongoc_DIST_cs}
   ${src_libmongoc_src_mongoc_DIST_hs}
   ${src_libmongoc_src_mongoc_DIST_noinst_hs}
   ${src_libmongoc_src_mongoc_DIST_defs}
)

## mongo-c-driver 1.24.2

=== debian/changelog ===
mongo-c-driver (1.24.2-1) unstable; urgency=medium

  * New upstream release

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Wed, 12 Jul 2023 16:23:39 +0000

mongo-c-driver (1.24.1-1) unstable; urgency=medium

  * New upstream release
  * Update to Standards-Version 4.6.2 (no changes)

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Fri, 23 Jun 2023 15:00:16 +0000

=== debian/control ===
Source: mongo-c-driver
Priority: optional
Maintainer: Mongo C Driver Team <mongo-c-driver-debian@googlegroups.com>
Uploaders: Kevin Albertson <kevin.albertson@mongodb.com>,
           Roberto C. Sanchez <roberto@connexer.com>,
           Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>
Build-Depends: debhelper (>= 11),
               cmake,
               libssl-dev,
               pkg-config,
               python3-sphinx,
               libmongocrypt-dev <!pkg.mongo-c-driver.no-libmongocrypt>,
               zlib1g-dev,
               libicu-dev,
               libsasl2-dev,
               libsnappy-dev,
               libzstd-dev
Standards-Version: 4.6.2
Section: libs
Homepage: https://github.com/mongodb/mongo-c-driver
Vcs-Git: https://github.com/mongodb/mongo-c-driver.git
Vcs-Browser: https://github.com/mongodb/mongo-c-driver/tree/master

Package: libmongoc-dev
Section: libdevel
Architecture: any
Build-Profiles: <!pkg.mongo-c-driver.no-libmongocrypt>
Depends: libmongoc-1.0-0 (= ${binary:Version}),
         libbson-dev (= ${binary:Version}),
         libmongocrypt-dev,
         libssl-dev,
         zlib1g-dev,
         libsnappy-dev,
         libsasl2-dev,
         libzstd-dev,
         ${misc:Depends}
Description: MongoDB C client library - dev files
 libmongoc is the officially supported MongoDB client library for C
 applications.
 .
 This package contains all files necessary to develop applications which
 use libmongoc.

Package: libmongoc-1.0-0
Architecture: any
Build-Profiles: <!pkg.mongo-c-driver.no-libmongocrypt>
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: MongoDB C client library - runtime files
 libmongoc is the officially supported MongoDB client library for C
 applications.
 .
 This package contains the libmongoc runtime libraries, for applications that
 have been built with libmongoc.

Package: libmongoc-doc
Section: doc
Architecture: all
Build-Profiles: <!pkg.mongo-c-driver.no-libmongocrypt>
Depends: libjs-mathjax,
         ${misc:Depends}
Description: MongoDB C client library - documentation
 libmongoc is the officially supported MongoDB client library for C
 applications.
 .
 This package contains the man pages for libmongoc.

Package: libbson-dev
Section: libdevel
Architecture: any
Depends: libbson-1.0-0 (= ${binary:Version}),
         ${misc:Depends}
Description: Library to parse and generate BSON documents - dev files
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains all files necessary to develop applications which
 use libbson.

Package: libbson-1.0-0
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Library to parse and generate BSON documents - runtime files
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the libbson runtime libraries, for applications that
 have been built with libbson.

Package: libbson-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Library to parse and generate BSON documents - documentation
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the man pages for libbson.
